package dev.shadowsoffire.apotheosis.spawn.modifiers;

import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Component;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import com.mojang.serialization.Codec;

public interface SpawnerStat<T>
{
    String getId();
    
    Codec<StatModifier<T>> getModifierCodec();
    
    T getValue(final ApothSpawnerTile p0);
    
    Component getTooltip(final ApothSpawnerTile p0);
    
    boolean apply(final T p0, final T p1, final T p2, final ApothSpawnerTile p3);
    
    default MutableComponent name() {
        return Component.m_237115_("stat.apotheosis." + this.getId());
    }
    
    default MutableComponent desc() {
        return Component.m_237115_("stat.apotheosis." + this.getId() + ".desc");
    }
}
